'Compilable Example:
#Compile Exe  "gbripple_bmp.exe"
#Dim All
#Debug Error On     'catch array/pointer errors - OFF in production
#Debug Display On   'display untrapped errors   - OFF in production

%Unicode = 1
#Include "Win32api.inc"

#Resource Icon logo, "icons\gbripple.ico"
#Resource Icon xnew, "icons\open.ico"
#Resource Icon xcopy, "icons\copy.ico"
#Resource Icon xsettings, "icons\settings.ico"
#Resource Icon xhelp, "icons\help.ico"
#Resource Icon xlock, "icons\lock.ico"
#Resource Icon xgray, "icons\gray.ico"
#Resource Icon xfit, "icons\fit.ico"
#Resource Icon xnext, "icons\next.ico"
#Resource Icon xclear, "icons\clear.ico"
#Resource Icon xrain, "icons\rain.ico"

$Ver = "1.13"

Enum Equates Singular
   IDC_Graphic = 500

   IDC_Toolbar
   IDC_Statusbar

   IDC_Radius
   IDC_Disturb
   IDC_Decay
   IDC_Refract
   IDC_Interval
   IDC_RadiusL
   IDC_DisturbL
   IDC_DecayL
   IDC_RefractL
   IDC_IntervalL

   IDC_RadiusText
   IDC_RadiusBuddy

   IDT_NewImage
   IDT_Copy
   IDT_Clear
   IDT_ExactFit
   IDT_LockImage
   IDT_Rain
   IDT_GrayScale
   IDT_NextImage
   IDT_Settings
   IDT_Help

   IDM_Defaults
   IDM_ShowTrackBars
   IDM_Sep
   ID_Timer
End Enum

Global hDlg,hToolbar,hFont,hSettings,hBMP,hGraphic As Dword
Global FileName As WStringZ * %Max_Path, ShowTrackBars, TBH As Long
Global bmpR$, bmpT$, Disturb,X0,Y0,Interval,Decay,Refract As Long
Global imgH, imgW, imgWN,imgHN, riprad, RippleMap(), Ripple(), Texture() As Long
Global GrayScale, oldind, newind, mapind, LockImage, Rain, RainCount, BGColor As Long
Global qFreq, qStart, qStop As Quad

Function PBMain() As Long
   Dialog New Pixels, 0, "gbRipple   v" + $ver,300,300,400,500, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"
   CreateTrackBars
   CreateToolbar
   Control Add Graphic, hDlg, %IDC_Graphic,"", 0,TBH,400,500
   Control Handle hDlg, %IDC_Graphic To hGraphic
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
   Graphic Color %Red, %Red
   Control Add Statusbar, hDlg, %IDC_StatusBar, "", 0,0,0,0
   Statusbar Set Parts hDlg, %IDC_StatusBar, 125,125,90,99999
   Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, Date$
   Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, Time$
   Statusbar Set Text hDlg, %IDC_StatusBar, 3, 0, Time$
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local PTT As TooltipText Ptr, NMTB As TBNotify Ptr, rc As Rect
   Local iResult As Long, UPD As NMUPDOWN Ptr
   Select Case Cb.Msg
      Case %WM_InitDialog
         Settings_INI "get"
         Statusbar Set Text hDlg, %IDC_StatusBar, 4, 0, "  " + PathName$(Namex,FileName)
         If IsFolder (Exe.Path$ + "images") = %False Then MkDir Exe.Path$ + "images"
         Dialog Set Text hDlg, "gbRipple   v" + $Ver
         QueryPerformanceFrequency qFreq
         BuildAcceleratorTable
         SetControlFonts
         ShowSettingsControls
         ApplyTrackBarSettings
         LoadBGImageToMemory
         SetMenusAndToolbar
         SetTimer hDlg, %ID_Timer, Interval, 0
      Case %WM_Timer
         If LockImage = 0 Then
            QueryPerformanceCounter   qStart
            Incr RainCount
            If Rain And (RainCount Mod 3 = 0) Then
               Splash Rnd(0,imgW)+X0, Rnd(0,imgH)+Y0-TBH-20, Rnd(1,3),Rnd(50,500)
            End If

            NewFrame : Graphic Set Bits bmpR$ : Graphic ReDraw
            QueryPerformanceCounter   qStop
            Statusbar Set Text hDlg, %IDC_StatusBar, 3,0," Cycle: " + Format$((qStop-qStart)/qFreq,"0.000")+"s"
         End If
      Case %WM_MouseMove, %WM_LButtonDown
         If LockImage = 0 Then
            If (Cb.WParam And %MK_LButton) Then Splash Lo(Word,Cb.LParam)-X0, Hi(Word,Cb.LParam)-Y0, RipRad, Disturb
         End If
      Case %WM_Size
         ReSizeWindow
      Case %WM_Destroy
         Settings_INI "save"
         KilLTimer hDlg, %ID_Timer
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDT_NewImage   : SelectAndOpenFile : ResizeWindow

            Case %IDT_Clear
               ResizeWindow

            Case %IDT_ExactFit
               FitDialogToImage

            Case %IDT_LockImage  : LockImage Xor= 1
            Case %IDT_Rain       : Rain Xor=1

            Case %IDT_NextImage
               ViewNextImage
               LoadBGImageToMemory
               ResizeWindow
               Dialog Set Text hDlg, "gbRipple   v" + $Ver

            Case %IDT_GrayScale
               GrayScale Xor=1
               LoadBGImageToMemory
               ResizeWindow

            Case %IDT_Copy
               Clipboard Reset
               Clipboard Set Bitmap hGraphic

            Case %IDT_Help
               iResult = ShellExecute(hDlg, "Open", "http://www.garybeene.com/sw/gbripple.htm", $Nul, $Nul, %SW_ShowNormal)

            Case %IDT_Settings
               ShowTrackBars Xor= 1
               ShowSettingsControls
               ResizeWindow

            Case %IDM_Defaults
               Decay = 90 : RipRad = 5 : Disturb = 512 : Interval = 40 : Refract = 1024
               ApplyTrackBarSettings
               KillTimer hDlg, %ID_Timer
               SetTimer hDlg, %ID_Timer, Interval, 0


         End Select
      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDT_NewImage To %IDT_Help
               Select Case Cb.NmCode
                  Case %TTN_GetDispInfo
                     PTT = Cb.LParam
                     Select Case Cb.NmId
                        Case %IDT_NewImage  : @PTT.@lpszText = "Select New Background"
                        Case %IDT_NextImage  : @PTT.@lpszText = "View Next Image"
                        Case %IDT_Copy      : @PTT.@lpszText = "Copy Image to Clipboard"
                        Case %IDT_Clear     : @PTT.@lpszText = "Clear All Ripples (Leave Background Intact)"
                        Case %IDT_ExactFit  : @PTT.@lpszText = "Resize Dialog to Fit Image"
                        Case %IDT_LockImage : @PTT.@lpszText = "Lock Image (Stop Animation)"
                        Case %IDT_Rain      : @PTT.@lpszText = "Enable Rain Drops"
                        Case %IDT_GrayScale : @PTT.@lpszText = "Display Image as Gray Scale"
                        Case %IDT_Settings  : @PTT.@lpszText = "Toggle Display of TrackBars"
                        Case %IDT_Help      : @PTT.@lpszText = "Open Online Help Page"
                     End Select
               End Select
            Case %IDC_Toolbar
               Select Case Cb.NmCode
                  Case %TBN_DROPDOWN
                     nmtb = Cb.LParam
                     Select Case @nmtb.iItem
                        Case %IDT_Settings
                           SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           Call TrackPopupMenu (hSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                     End Select
               End Select
         End Select
      Case %WM_HScroll
         Select Case Cb.LParam
            Case GetDlgItem(hDlg, %IDC_Refract)
               Control Send Cb.Hndl, %IDC_Refract, %TBM_GetPos, 0, 0 To Refract 'get pos
               ApplyTrackbarSettings
            Case GetDlgItem(hDlg, %IDC_Decay)
               Control Send Cb.Hndl, %IDC_Decay, %TBM_GetPos, 0, 0 To Decay 'get pos
               ApplyTrackbarSettings
            Case GetDlgItem(hDlg, %IDC_Radius)
               Control Send Cb.Hndl, %IDC_Radius, %TBM_GetPos, 0, 0 To RipRad 'get pos
               ApplyTrackbarSettings
            Case GetDlgItem(hDlg, %IDC_Disturb)
               Control Send Cb.Hndl, %IDC_Disturb, %TBM_GetPos, 0, 0 To Disturb 'get pos
               ApplyTrackbarSettings
            Case GetDlgItem(hDlg, %IDC_Interval)
               Control Send Cb.Hndl, %IDC_Interval, %TBM_GetPos, 0, 0 To Interval 'get pos
               ApplyTrackbarSettings
               KillTimer hDlg, %ID_Timer
               SetTimer hDlg, %ID_Timer, Interval, 0
         End Select
   End Select
End Function

Sub CreateToolbar
    Local hImageList As Dword
    ImageList New Icon 24,24,24,50 To hImageList
    ImageList Add Icon hImageList, "xnew"       '1
    ImageList Add Icon hImageList, "xcopy"      '2
    ImageList Add Icon hImageList, "xlock"      '3
    ImageList Add Icon hImageList, "xsettings"  '4
    ImageList Add Icon hImageList, "xhelp"      '5
    ImageList Add Icon hImageList, "xgray"      '6
    ImageList Add Icon hImageList, "xfit"       '7
    ImageList Add Icon hImageList, "xnext"      '8
    ImageList Add Icon hImageList, "xclear"     '9
    ImageList Add Icon hImageList, "xrain"     '10

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0,%TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0

    Toolbar Add Button    hDlg, %IDC_Toolbar, 1,  %IDT_NewImage, %BTNS_Button, "New"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 8,  %IDT_NextImage, %BTNS_Button, "Next"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 9,  %IDT_Clear,  %BTNS_Button, "Clear"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 2,  %IDT_Copy,  %BTNS_Button, "Copy"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 7,  %IDT_ExactFit,  %BTNS_Button, "Fit"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 3,  %IDT_LockImage,  %BTNS_Check, "Lock"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 10,  %IDT_Rain,  %BTNS_Check, "Rain"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 6,  %IDT_GrayScale,  %BTNS_Check, "GrayScale"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 4,  %IDT_Settings,  %BTNS_Button Or %BTNS_DropDown, "Settings"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 5,  %IDT_Help,  %BTNS_Button, "Help"

    Menu New PopUp To hSettings
'    Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hSettings, "Apply Default Settings", %IDM_Defaults, %MF_Enabled

End Sub

Sub Settings_INI(Task$)
   Local x,y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "100", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "100", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "500", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "485", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FileName", "images\foot.bmp", FileName, %Max_Path, INIFileName
      'get value for numeric variables
      Getprivateprofilestring "All", "LockImage", "0", temp, %Max_Path, INIFileName:  LockImage = Val(temp)
      Getprivateprofilestring "All", "BGColor", Str$(%Yellow), temp, %Max_Path, INIFileName:  BGColor = Val(temp)
      Getprivateprofilestring "All", "GrayScale", "0", temp, %Max_Path, INIFileName:  GrayScale = Val(temp)
      Getprivateprofilestring "All", "RipRad", "5", temp, %Max_Path, INIFileName:  RipRad = Val(temp)
      Getprivateprofilestring "All", "Disturb", "512", temp, %Max_Path, INIFileName:  Disturb = Val(temp)
      Getprivateprofilestring "All", "Decay", "90", temp, %Max_Path, INIFileName:  Decay = Val(temp)
      Getprivateprofilestring "All", "Refract", "1024", temp, %Max_Path, INIFileName:  Refract = Val(temp)
      Getprivateprofilestring "All", "Interval", "40", temp, %Max_Path, INIFileName:  Interval = Val(temp)
      Getprivateprofilestring "All", "GrayScale", "0", temp, %Max_Path, INIFileName:  GrayScale = Val(temp)
      Getprivateprofilestring "All", "Rain", "0", temp, %Max_Path, INIFileName:  Rain = Val(temp)
      Getprivateprofilestring "All", "ShowTrackBars", "0", temp, %Max_Path, INIFileName:  ShowTrackBars = Val(temp)
      Getprivateprofilestring "All", "TBH", "210", temp, %Max_Path, INIFileName:  TBH = Val(temp)

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FileName",FileName, INIFileName
      'save numeric variables
      WritePrivateProfileString "All", "LockImage", Str$(LockImage), INIFileName
      WritePrivateProfileString "All", "BGColor", Str$(BGColor), INIFileName
      WritePrivateProfileString "All", "GrayScale", Str$(GrayScale), INIFileName
      WritePrivateProfileString "All", "RipRad", Str$(RipRad), INIFileName
      WritePrivateProfileString "All", "Disturb", Str$(Disturb), INIFileName
      WritePrivateProfileString "All", "Decay", Str$(Decay), INIFileName
      WritePrivateProfileString "All", "Refract", Str$(Refract), INIFileName
      WritePrivateProfileString "All", "Interval", Str$(Interval), INIFileName
      WritePrivateProfileString "All", "GrayScale", Str$(GrayScale), INIFileName
      WritePrivateProfileString "All", "Rain", Str$(Rain), INIFileName
      WritePrivateProfileString "All", "ShowTrackBars", Str$(ShowTrackBars), INIFileName
      WritePrivateProfileString "All", "TBH", Str$(TBH), INIFileName
   End If
End Sub

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(2)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1 : ac(c).cmd   = %IDT_Help       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_N  : ac(c).cmd   = %IDT_NewImage   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_C  : ac(c).cmd   = %IDT_Copy       : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Function SelectAndOpenFile As Long
    Local startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    filter$ = "Image Files (*.bmp)" + $Nul + "*.bmp" + $Nul
    startfolder$ = IIf$(IsFile(FileName), FileName, Exe.Path$)     'initial folder to be displayed
    startfile$ = (FileName)       'name to be used as initial selection
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, "", startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
       FileName = filevar$
       Statusbar Set Text hDlg, %IDC_StatusBar, 4, 0, "  " + PathName$(Namex,FileName)
       LoadBGImageToMemory
    End If
End Function

Sub LoadBGImageToMemory
   If IsFalse(IsFile(FileName)) Then Exit Sub

   'load FileName
   Graphic Bitmap Load FileName, 0, 0 To hBmp
   Graphic Attach hBMP, 0
   Graphic Get Canvas To imgWN, imgHN

   If GrayScale Then CreateGrayScale

End Sub

Sub CreateGrayScale
   Local i As Long, p As Long Ptr, bmp$, R,G,B As Single, iColor As Dword

   'get the string from ID_Graphic
   Graphic Attach hBMP, 0
   Graphic Get Bits To bmp$
   p = StrPtr(bmp$)+8    'position of starting position for bits in string
   'get string position of coordinates and modify the string at that position
   For i = 1 To imgWN * imgHN
      'get RGB component values
      iColor = @p                           'result is a BGR color value 0-R-G-B
      B = iColor Mod 256                    'or this: iColor AND &HFF&
      G = (iColor\256) Mod 256              'or this: (iColor AND &HFF00&) \ &H100
      R = (iColor\256\256) Mod 256          'or this: (iColor AND &HFF0000&) \ &H10000&
      iColor = 0.299*R + 0.587*G + 0.114*B  'or this: iColor = (R+G+B)/3
      @p = Bgr(iColor, iColor, iColor)      'modify string at that position
      Incr p
   Next i
   'put the modified string back into selected Graphic target
   Graphic Set Bits bmp$

   'return control to %IDC_Graphic
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
End Sub

Sub SetControlFonts
   Local i As Long
   Font New "Tahoma",10,0 To hFont
   For i = %IDC_Toolbar To %IDC_IntervalL
      Control Set Font hDlg, i, hFont
   Next i
End Sub

Sub SetMenusAndToolbar
   'Toolbar Buttons
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_LockImage, %TBState_Checked * LockImage Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_GrayScale, %TBState_Checked * GrayScale Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Rain, %TBState_Checked * Rain Or %TBState_Enabled
   'Menus
'    Menu Set State hSettings, ByCmd %IDM_AutoFit, AutoFit * %MFS_Checked Or %MFS_Enabled
End Sub

Sub CreateTrackBars
   Control Add Label, hDlg, %IDC_DecayL, "",    20,55,200,20
   Control Add Label, hDlg, %IDC_RadiusL, "",  240,55,200,20
   Control Add Label, hDlg, %IDC_DisturbL, "",   20,105,200,20
   Control Add Label, hDlg, %IDC_IntervalL, "", 240,105,200,20
   Control Add Label, hDlg, %IDC_RefractL, "",   20,155,200,20

   Control Add "msctls_trackbar32", hDlg, %IDC_Decay   , "",  20, 75,200,20, %WS_Child Or %WS_Visible Or %TBS_AutoTicks
   Control Add "msctls_trackbar32", hDlg, %IDC_Radius  , "", 240, 75,200,20, %WS_Child Or %WS_Visible Or %TBS_AutoTicks
   Control Add "msctls_trackbar32", hDlg, %IDC_Disturb , "",  20,125,200,20, %WS_Child Or %WS_Visible Or %TBS_AutoTicks
   Control Add "msctls_trackbar32", hDlg, %IDC_Interval, "", 240,125,200,20, %WS_Child Or %WS_Visible Or %TBS_AutoTicks
   Control Add "msctls_trackbar32", hDlg, %IDC_Refract, "",   20,175,200,20, %WS_Child Or %WS_Visible Or %TBS_AutoTicks

   Control Send hDlg, %IDC_Decay, %TBM_SetRange, 0, Mak(Long,    1, 100) ' range
   Control Send hDlg, %IDC_Radius, %TBM_SetRange, 0, Mak(Long,   1,  15) ' range
   Control Send hDlg, %IDC_Disturb, %TBM_SetRange, 0, Mak(Long,  1,2048) ' range
   Control Send hDlg, %IDC_Interval, %TBM_SetRange, 0, Mak(Long, 1, 200) ' range
   Control Send hDlg, %IDC_Refract, %TBM_SetRange, 0, Mak(Long,  0,2048) ' range

   Control Send hDlg, %IDC_Decay, %TBM_SetTicFreq,     5, 0  ' interval frequency
   Control Send hDlg, %IDC_Radius, %TBM_SetTicFreq,    1, 0  ' interval frequency
   Control Send hDlg, %IDC_Disturb, %TBM_SetTicFreq, 256, 0  ' interval frequency
   Control Send hDlg, %IDC_Interval, %TBM_SetTicFreq, 20, 0  ' interval frequency
   Control Send hDlg, %IDC_Refract, %TBM_SetTicFreq, 256, 0  ' interval frequency
End Sub

Sub ShowSettingsControls
   Local iPos,x,y As Long
   If ShowTrackBars Then TBH = 210 Else TBH = 55 : iPos = 1000

   Control Set Loc hDlg, %IDC_DecayL,     20-iPos,55
   Control Set Loc hDlg, %IDC_RadiusL,   240-iPos,55
   Control Set Loc hDlg, %IDC_DisturbL,   20-iPos,105
   Control Set Loc hDlg, %IDC_IntervalL, 240-iPos,105
   Control Set Loc hDlg, %IDC_RefractL,  20-iPos,155

   Control Set Loc hDlg, %IDC_Decay   ,  20-iPos, 75
   Control Set Loc hDlg, %IDC_Radius  , 240-iPos, 75
   Control Set Loc hDlg, %IDC_Disturb ,  20-iPos,125
   Control Set Loc hDlg, %IDC_Interval, 240-iPos,125
   Control Set Loc hDlg, %IDC_Refract,   20-iPos,175
End Sub

Sub ApplyTrackBarSettings
   Control Send hDlg, %IDC_Decay, %TBM_SetPos, %True, Decay
   Control Send hDlg, %IDC_Radius, %TBM_SetPos, %True, RipRad
   Control Send hDlg, %IDC_Disturb, %TBM_SetPos, %True, Disturb
   Control Send hDlg, %IDC_Interval, %TBM_SetPos, %True, Interval
   Control Send hDlg, %IDC_Refract, %TBM_SetPos, %True, Refract
   Control Set Text hDlg, %IDC_DecayL, "Decay (1-100):  " + Str$(Decay)
   Control Set Text hDlg, %IDC_RadiusL,  "Ripple Radius (1-15):  " + Str$(RipRad)
   Control Set Text hDlg, %IDC_DisturbL, "Splash Height (1-2048):  " + Str$(Disturb)
   Control Set Text hDlg, %IDC_IntervalL, "Timer Interval (1-150):  " + Str$(Interval)
   Control Set Text hDlg, %IDC_RefractL, "Refraction Dist (1-2048):  " + Str$(Refract)
End Sub

Sub FitDialogtoImage
   Local w,h As Long
   Dialog Set Client hDlg, imgWN, imgHN + TBH + 25
   ResizeWindow
End Sub

Sub ViewNextImage
   'view next image in same folder as current image
   Local FileFound As Long, temp$,File$,Folder$

   File$   = LCase$(PathName$(Namex,FileName))
   Folder$ = LCase$(PathName$(Path, FileName))
   If IsFalse(IsFolder(Folder$)) Then Folder$ = LCase$(Exe.Path$) + "images\"

   temp$ = LCase$(Dir$(Folder$ + "*.bmp"))
   While Len(temp$)
      If Folder$ + temp$ = LCase$(FileName) Then
         temp$ = LCase$(Dir$)   'next file
         Exit Loop
      End If
      temp$ = LCase$(Dir$)
   Wend

   If Len(temp$) Then
      FileName = Folder$ + temp$   'first file found behind FileName
   Else
      FileName = Folder$ + Dir$(Folder$ + "*.bmp")  'use first file found in the folder
   End If
   Statusbar Set Text hDlg, %IDC_StatusBar, 4, 0, "  " + PathName$(Namex,FileName)
End Sub

Sub ResizeWindow
   Local w,h,wNew,hNew As Long
   'relocate Graphic Control
   Dialog Get Client hDlg To w,h
   imgW = imgWN / Max(imgWN / w, imgHN / (h-TBH-25))
   imgH = imgHN / Max(imgWN / w, imgHN / (h-TBH-25))
   X0 = (w-imgW)/2 : Y0 = (h-TBH-imgH-25)/2 + TBH
   Control Set Loc hDlg, %IDC_Graphic, X0,Y0

   'resize Graphic Control
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
   Graphic Set Client imgW, imgH

   'stretch image into Graphic background
   Graphic Stretch Page hBMP, 0, %Mix_CopySrc, %HalfTone     'Graphic Stretch hBMP, 0, (0,0)-(imgWN-1,imgHN-1) To (0,0)-(imgW-1,imgH-1), %Mix_CopySrc, %HalfTone
   Graphic Get Bits To bmpT$
   bmpR$ = bmpT$

   'resize arrays to match new Graphic size
   ReDim RippleMap(imgW*(imgH+2) * 2)
   ReDim Texture(imgW*imgH) As Long At StrPtr(bmpT$) + 8
   ReDim Ripple(imgW*imgH) As Long At StrPtr(bmpR$)  + 8

   'ripplemap variables
   oldind = imgW
   newind = imgW * (imgH+3)

   Graphic ReDraw

   'statusbar
   Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "File: " + Str$(imgWN) + "x" + Str$(imgHN)
   Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, "Display: " + Str$(imgW) + "x" + Str$(imgH)
   Control ReDraw hDlg, %IDC_Statusbar
End Sub

Sub Splash(dxx As Long, dyy As Long, RRadius As Long, DHeight As Long)
   Local j,k As Long
   For j = dyy - RRadius To dyy + RRadius
      For k = dxx - RRadius To dxx + RRadius
         If (j>=0 And j<imgH And k>=0 And k<imgW) Then ripplemap(oldind+(j*imgW)+k) += DHeight
      Next k
   Next j
End Sub

Sub NewFrame
   Local i,x,y,xData,a,b As Long
   Swap oldind, newind   'toggle maps each frame
   mapind=oldind
   For y = 0 To imgH-1
      For x = 0 To imgW-1
         xData = (ripplemap(mapind-imgW)+ripplemap(mapind+imgW)+ripplemap(mapind-1)+ripplemap(mapind+1))\2
         xData -= ripplemap(newind+i)        'subtract value in current state map
         xData = xData - xData / (100-Decay) 'decay value each frame
         ripplemap(newind+i)=xData           'set the height value in the next frame
         xData = (2*Disturb-xdata)           'where xData=0 then still, where xdata>0 then wave
         a=((x-imgW\2)*xData/Refract)+imgW\2 'color displayed is based on offset position (gives distortion)
         b=((y-imgH\2)*xData/Refract)+imgH\2 'color displayed is based on offset position (gives distortion)
         If a>=imgW Then a=imgW-1            'bounds check
         If a<0 Then a=0                     'bounds check
         If b>=imgH Then b=imgH-1            'bounds check
         If b<0 Then b=0                     'bounds check
         Ripple(i)=Texture(a+b*imgW)         'set color to be displayed
         Incr mapind                         'next location in target state map
         Incr i                              'next location in current state map
      Next x
   Next Y
End Sub
